Ext.define('DSS.addon.HueController.SelectPreset', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    getHeight:function () {
                 return this.iDefaultHeight;
    },
    
    height : '100%',
    grids : {},
    selectedRoomID : -1,
    presetID : -1,
    macPanel : null,
    arrayAllPresets:null,
    iDefaultWidth : 150,
    iDefaultHeight : 332,
    onNewZoneIDSelected: null,
    extraInfo: null,
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
       var fIsPassive=false;        
       if (record.get('passive')!=null)
         if (record.get('passive'))
           fIsPassive=true;
        var fHasNext=false;
        if (record.get('next') == true)  {
            fHasNext=true;
        }
        var fHasIcon=false;
        if (record.get('icon') != null) {
            fHasIcon=true;
        }        
           
       var sReturn='<table style="height:16px;"><tr>';
       var iColspaceCounter=3;
       if (fHasIcon) {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
       if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       } 
       else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       }
       if (fHasNext) {
            sReturn+='<td>&gt;</td>';
       }
       
       return sReturn +'</tr></table>';      
    },
    initStores : function(bLoadAllPresetRooms)
    {
	var actions = new Array();

	var zones = dss.staticDataModel.getZoneArray();

	for (var i = 0; i < zones.length; ++i)
	{
		if (zones[i].ZoneID > 0)
		{
			/* if a lightsInZones table is available, then this table contains a list of lights for each zone
			 * this can be used to check if the current zone has any associated lights */
                        if (this.extraInfo && this.extraInfo.hueBridgeInfo && this.extraInfo.lightsInZonesTable)
			{
				var lightsInZone = this.extraInfo.lightsInZonesTable[zones[i].ZoneID];
				if ((lightsInZone === null) || (lightsInZone === undefined) || (lightsInZone.length === 0))
					continue; // no lights associated to this zone -> do not include zone in list
			}

			actions.push(new Object({
				name: zones[i].name,
				_id: parseInt("" + zones[i].ZoneID),
				icon: null, passive:false, next: true
			}));
		}
	}

        Ext.create(
		'Ext.data.Store',
		{
			storeId : 'selectpreset_l1',
			fields : [ '_id', 'name', 'next', 'icon' ,'passive'],
			proxy :
			{
				type : 'memory',
				reader :
				{
					type : 'json',
					root : 'items'
				}
			}
        	}
	);
	Ext.data.StoreManager.lookup('selectpreset_l1').add(actions);
    },
    constructGridLvlPresets : function() {

        // for selected room test which preset are still available
        var arrayUsedPresets = new Array();
        if (this.selectedRoomID > 0 && this.arrayAllPresets != null) {
           for ( var iIndex = 0; iIndex < this.arrayAllPresets.length; iIndex++) {
             var nRoomID = parseInt("" + this.arrayAllPresets[iIndex].roomID, 10);
             var presetID = parseInt("" + this.arrayAllPresets[iIndex].presetID, 10);
             if (nRoomID == this.selectedRoomID && 
                 (this.presetID == -1 || (this.presetID>-1 && this.presetID != presetID)) // on edit we skip currently edited preset
                )
               arrayUsedPresets.push(presetID);
           }
        }
        
        if (Ext.data.StoreManager.lookup('selectpreset_list') != null) {
          Ext.data.StoreManager.lookup('selectpreset_list').removeAll();
        }
        else {
          Ext.create('Ext.data.Store', {
             storeId : 'selectpreset_list',
             fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
          });
        }
         
        var arrayPresets = new Array();
        var lightPresetSceneIDs = [
		5,17,18,19, // Scene IDs for: T0_S1, T0_S2, T0_S3, T0_S4
		6,20,21,22, // Scene IDs for: T1_S1, T1_S2, T1_S3, T1_S4
		7,23,24,25, // Scene IDs for: T2_S1, T2_S2, T2_S3, T2_S4
		8,26,27,28, // Scene IDs for: T3_S1, T3_S2, T3_S3, T3_S4
		9,29,30,31, // Scene IDs for: T4_S1, T4_S2, T4_S3, T4_S4
	];
        var me = this;
        Ext.Array.each(lightPresetSceneIDs, function(sceneID)
        {
            var zoneID = me.selectedRoomID;
            var groupID = 1;

            var name = getCustomNameForScene(sceneID, groupID, zoneID);
            arrayPresets.push(new Object({name: name, _id : sceneID, icon: '/framework/images/groupIcons/group_1_active.png', passive:(arrayUsedPresets.indexOf(sceneID)!=-1), next: false}));
        });
   
        Ext.data.StoreManager.lookup('selectpreset_list').add(arrayPresets);                     
     
        this.grids.lvlPresets = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('selectpreset_list'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlPresets.parent = this;

        this.grids.lvlPresets.on('itemclick', function(grid, record) {
            if (record.get('passive')) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids.lvlPresets);

    },
    constructMacGrids : function() {
      var me = this;
      this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
          hideHeaders:true,
          height : this.iDefaultHeight,
          width : this.iDefaultWidth,
          autoScroll : true,
          viewConfig : {
              stripeRows : true
          },
          selModel : {
              mode : 'SINGLE'
          },
          columns : [ {
              sortable : false,
              hideable : false,
              dataIndex : 'name',
              flex : 1,
              renderer : this.defMacGridRenderer
          } ]
      });
      this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
      this.grids.lvl1.parent = this;

      this.grids.lvl1.on('itemclick', function(grid, record) {
          this.parent.macPanel.remove(this.parent.grids.lvlPresets);
          me.selectedRoomID = record.get('_id');
          if (me.onNewZoneIDSelected)
              me.onNewZoneIDSelected(me.selectedRoomID);
          this.parent.constructGridLvlPresets();
      }); 
    },
    constructor : function(config) {
        this.extraInfo = config.extraInfo;
        this.initStores(false);
        this.constructMacGrids();

        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            autoScroll : true,
            height : this.iDefaultHeight+2,
            layout : {
                type : 'hbox'
            },
            items : [ this.grids.lvl1 ],
            scroll : 'horizontal'
        });
        
        Ext.apply(this, {
            items : [ this.macPanel ]
        });

        this.callParent(arguments);
    },
    reset : function() {
      this.selectedRoomID = -1;
      this.presetID = -1;
      this.initStores(false);
      this.grids.lvl1.reconfigure(Ext.data.StoreManager.lookup('selectpreset_l1'));
      this.macPanel.remove(this.grids.lvlPresets); 
    },
    setValue: function(values)
    {
	this.initStores(true);
	this.grids.lvl1.reconfigure(Ext.data.StoreManager.lookup('selectpreset_l1'));
	this.macPanel.remove(this.grids.lvlPresets); 

	var trigger = values[0];

	var store = this.grids.lvl1.getStore();
	var foundRec = store.getAt(store.findExact('_id', parseInt(String(trigger.zone), 10)));
	this.grids.lvl1.getSelectionModel().select(foundRec);

	this.selectedRoomID = trigger.zone;
        if (this.onNewZoneIDSelected)
            this.onNewZoneIDSelected(this.selectedRoomID);
	this.presetID = trigger.scene;
	this.constructGridLvlPresets();
	var recordZone2 = this.grids.lvlPresets.store.find('_id', trigger.scene, 0, false,false,true);
	if (recordZone2 != -1)
		this.grids.lvlPresets.getSelectionModel().select(recordZone2);
    },
    getValue: function()
    {
	var trigger = {};

	try
	{
		var selectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
		if (this.grids.lvlPresets != null)
		{
			var selectionPlaylist = this.grids.lvlPresets.getSelectionModel().getSelection();

			trigger =
			{
				type: 'zone-scene',
				zone: selectionLVL1[0].get('_id'),
				group: 1,
				scene: selectionPlaylist[0].get('_id')
			};
		}
	}
	catch (err)
	{
	}

	return [trigger]; // main UI expects an array
    },
    isValid : function() {
       var bValid = false;
     
       var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
       if (this.grids.lvlPresets != null) {
         var oSelectionPreset = this.grids.lvlPresets.getSelectionModel().getSelection();
         if (oSelectionLVL1[0] != null && oSelectionPreset[0] != null)
           bValid = true;
       }
       return bValid;
    }
});

